=== HDF4Examples/C/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.18)
project (HDF4Examples_C C)

#-----------------------------------------------------------------------------
# Define Sources
#-----------------------------------------------------------------------------
add_subdirectory (${PROJECT_SOURCE_DIR}/AN)
add_subdirectory (${PROJECT_SOURCE_DIR}/GR)
add_subdirectory (${PROJECT_SOURCE_DIR}/VD)
add_subdirectory (${PROJECT_SOURCE_DIR}/VG)
add_subdirectory (${PROJECT_SOURCE_DIR}/SD)
