=== java/src/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.18)
project (HDF4_JAVA_SRC C)

#-----------------------------------------------------------------------------
# Traverse source subdirectory
#-----------------------------------------------------------------------------
add_subdirectory (jni)
add_subdirectory (hdf)
