=== debian/changelog ===
libhdf4 (4.3.1-1) unstable; urgency=medium

  * Team upload.
  * Move from experimental to unstable.

 -- Bas Couwenberg <sebastic@debian.org>  Sun, 10 Aug 2025 12:49:03 +0200

libhdf4 (4.3.1-1~exp2) experimental; urgency=medium

  * Team upload.
  * Drop -alt transitional packages, rdeps expect the alt files which are gone.

 -- Bas Couwenberg <sebastic@debian.org>  Wed, 02 Jul 2025 21:42:49 +0200

libhdf4 (4.3.1-1~exp1) experimental; urgency=medium

  * Team upload.
  * New upstream release.
    (closes: #1097195)
  * Bump Standards-Version to 4.7.2, no changes.
  * Fix old FSF address in copyright file.
  * Add get-orig-source script for upstream git snapshots.
  * Drop -alt variant, it replaced the variant with netcdf & fortran support.
    (closes: #1107056)
  * Don't include .la file in -dev package.
  * Remove generated files in clean target.
  * Replace obsolete Breaks/Conflicts/Replaces.
  * Drop obsolete patches.

 -- Bas Couwenberg <sebastic@debian.org>  Tue, 01 Jul 2025 05:29:49 +0200
