=== debian/watch ===
version=4
opts=\
dversionmangle=s/\+(debian|dfsg|ds|deb)\d*$//,\
uversionmangle=s/(\d)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha)\d*)$/$1~$2/;s/[_-]/./g,\
filenamemangle=s/(?:.*\/)?(?:rel|v|hdf)[\-\_]?(\d\S*)\.(tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))/hdf4-$1.$2/ \
https://github.com/HDFGroup/hdf4/tags \
(?:.*?/archive/(?:.*?/)?)?(?:rel|v|hdf)[\-\_]?(\d\S*)\.(?:tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))
